=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module HappyCo
  class AssetServiceApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1AddAssetPhotoResponse]
    def add_asset_photo(body, opts = {})
      data, _status_code, _headers = add_asset_photo_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1AddAssetPhotoResponse, Fixnum, Hash)>] V1AddAssetPhotoResponse data, response status code and response headers
    def add_asset_photo_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AssetServiceApi.add_asset_photo ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling AssetServiceApi.add_asset_photo" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/asset/photo/add".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1AddAssetPhotoResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetServiceApi#add_asset_photo\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1SetAssetsArchivedResponse]
    def archive_assets(body, opts = {})
      data, _status_code, _headers = archive_assets_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1SetAssetsArchivedResponse, Fixnum, Hash)>] V1SetAssetsArchivedResponse data, response status code and response headers
    def archive_assets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AssetServiceApi.archive_assets ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling AssetServiceApi.archive_assets" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/assets/archive".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1SetAssetsArchivedResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetServiceApi#archive_assets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1CreateAssetsResponse]
    def create_assets(body, opts = {})
      data, _status_code, _headers = create_assets_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1CreateAssetsResponse, Fixnum, Hash)>] V1CreateAssetsResponse data, response status code and response headers
    def create_assets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AssetServiceApi.create_assets ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling AssetServiceApi.create_assets" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/assets/create".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1CreateAssetsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetServiceApi#create_assets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1ListAssetsResponse]
    def list_assets(body, opts = {})
      data, _status_code, _headers = list_assets_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1ListAssetsResponse, Fixnum, Hash)>] V1ListAssetsResponse data, response status code and response headers
    def list_assets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AssetServiceApi.list_assets ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling AssetServiceApi.list_assets" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/assets/list".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1ListAssetsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetServiceApi#list_assets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1SetAssetsArchivedResponse]
    def unarchive_assets(body, opts = {})
      data, _status_code, _headers = unarchive_assets_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1SetAssetsArchivedResponse, Fixnum, Hash)>] V1SetAssetsArchivedResponse data, response status code and response headers
    def unarchive_assets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AssetServiceApi.unarchive_assets ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling AssetServiceApi.unarchive_assets" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/assets/unarchive".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1SetAssetsArchivedResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetServiceApi#unarchive_assets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1UpdateAssetsResponse]
    def update_assets(body, opts = {})
      data, _status_code, _headers = update_assets_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1UpdateAssetsResponse, Fixnum, Hash)>] V1UpdateAssetsResponse data, response status code and response headers
    def update_assets_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AssetServiceApi.update_assets ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling AssetServiceApi.update_assets" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/assets/update".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1UpdateAssetsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AssetServiceApi#update_assets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
