=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module HappyCo
  class FolderServiceApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1CreateFoldersResponse]
    def create_folders(body, opts = {})
      data, _status_code, _headers = create_folders_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1CreateFoldersResponse, Fixnum, Hash)>] V1CreateFoldersResponse data, response status code and response headers
    def create_folders_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FolderServiceApi.create_folders ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling FolderServiceApi.create_folders" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/folders/create".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1CreateFoldersResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FolderServiceApi#create_folders\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1ListFoldersResponse]
    def list_folders(body, opts = {})
      data, _status_code, _headers = list_folders_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1ListFoldersResponse, Fixnum, Hash)>] V1ListFoldersResponse data, response status code and response headers
    def list_folders_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FolderServiceApi.list_folders ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling FolderServiceApi.list_folders" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/folders/list".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1ListFoldersResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FolderServiceApi#list_folders\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1UpdateFolderStatusesResponse]
    def update_folder_statuses(body, opts = {})
      data, _status_code, _headers = update_folder_statuses_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1UpdateFolderStatusesResponse, Fixnum, Hash)>] V1UpdateFolderStatusesResponse data, response status code and response headers
    def update_folder_statuses_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FolderServiceApi.update_folder_statuses ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling FolderServiceApi.update_folder_statuses" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/folder/statuses/update".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1UpdateFolderStatusesResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FolderServiceApi#update_folder_statuses\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1UpdateFoldersResponse]
    def update_folders(body, opts = {})
      data, _status_code, _headers = update_folders_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1UpdateFoldersResponse, Fixnum, Hash)>] V1UpdateFoldersResponse data, response status code and response headers
    def update_folders_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: FolderServiceApi.update_folders ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling FolderServiceApi.update_folders" if body.nil?
      # resource path
      local_var_path = "/api/v1/manage/folders/update".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1UpdateFoldersResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: FolderServiceApi#update_folders\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
