=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module HappyCo
  class InspectionServiceApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # * No longer supported since 2.6.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1AddInspectionPhotosResponse]
    def add_inspection_photos(body, opts = {})
      data, _status_code, _headers = add_inspection_photos_with_http_info(body, opts)
      return data
    end

    # * No longer supported since 2.6.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1AddInspectionPhotosResponse, Fixnum, Hash)>] V1AddInspectionPhotosResponse data, response status code and response headers
    def add_inspection_photos_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: InspectionServiceApi.add_inspection_photos ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling InspectionServiceApi.add_inspection_photos" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/inspection/photos/add".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1AddInspectionPhotosResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InspectionServiceApi#add_inspection_photos\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # * Archive inspections should be used to archive inspections that are no longer wanted. No method for purging archived inspections is available via the API. All inspections must belong to the same folder.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1SetInspectionsArchivedResponse]
    def archive_inspections(body, opts = {})
      data, _status_code, _headers = archive_inspections_with_http_info(body, opts)
      return data
    end

    # * Archive inspections should be used to archive inspections that are no longer wanted. No method for purging archived inspections is available via the API. All inspections must belong to the same folder.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1SetInspectionsArchivedResponse, Fixnum, Hash)>] V1SetInspectionsArchivedResponse data, response status code and response headers
    def archive_inspections_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: InspectionServiceApi.archive_inspections ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling InspectionServiceApi.archive_inspections" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/inspections/archive".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1SetInspectionsArchivedResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InspectionServiceApi#archive_inspections\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1CreateDelegatedInspectionLinksResponse]
    def create_delegated_inspection_links(body, opts = {})
      data, _status_code, _headers = create_delegated_inspection_links_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1CreateDelegatedInspectionLinksResponse, Fixnum, Hash)>] V1CreateDelegatedInspectionLinksResponse data, response status code and response headers
    def create_delegated_inspection_links_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: InspectionServiceApi.create_delegated_inspection_links ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling InspectionServiceApi.create_delegated_inspection_links" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/inspection/links/create".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1CreateDelegatedInspectionLinksResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InspectionServiceApi#create_delegated_inspection_links\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # * Create inspections can create inspections with any status (normally scheduled).
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1CreateInspectionsResponse]
    def create_inspections(body, opts = {})
      data, _status_code, _headers = create_inspections_with_http_info(body, opts)
      return data
    end

    # * Create inspections can create inspections with any status (normally scheduled).
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1CreateInspectionsResponse, Fixnum, Hash)>] V1CreateInspectionsResponse data, response status code and response headers
    def create_inspections_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: InspectionServiceApi.create_inspections ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling InspectionServiceApi.create_inspections" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/inspections/create".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1CreateInspectionsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InspectionServiceApi#create_inspections\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # * List inspections gets a paginated and optionally filtered list of inspections from one or more folders.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1ListInspectionsResponse]
    def list_inspections(body, opts = {})
      data, _status_code, _headers = list_inspections_with_http_info(body, opts)
      return data
    end

    # * List inspections gets a paginated and optionally filtered list of inspections from one or more folders.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1ListInspectionsResponse, Fixnum, Hash)>] V1ListInspectionsResponse data, response status code and response headers
    def list_inspections_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: InspectionServiceApi.list_inspections ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling InspectionServiceApi.list_inspections" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/inspections/list".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1ListInspectionsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InspectionServiceApi#list_inspections\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # * Unarchive inspections should be used if previously archived inspections need to be restored. All inspections must belong to the same folder.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1SetInspectionsArchivedResponse]
    def unarchive_inspections(body, opts = {})
      data, _status_code, _headers = unarchive_inspections_with_http_info(body, opts)
      return data
    end

    # * Unarchive inspections should be used if previously archived inspections need to be restored. All inspections must belong to the same folder.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1SetInspectionsArchivedResponse, Fixnum, Hash)>] V1SetInspectionsArchivedResponse data, response status code and response headers
    def unarchive_inspections_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: InspectionServiceApi.unarchive_inspections ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling InspectionServiceApi.unarchive_inspections" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/inspections/unarchive".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1SetInspectionsArchivedResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InspectionServiceApi#unarchive_inspections\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # * Update inspections can change the contents of inspections. Currently an inspection cannot have its asset_id or template_id updated.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1UpdateInspectionsResponse]
    def update_inspections(body, opts = {})
      data, _status_code, _headers = update_inspections_with_http_info(body, opts)
      return data
    end

    # * Update inspections can change the contents of inspections. Currently an inspection cannot have its asset_id or template_id updated.
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1UpdateInspectionsResponse, Fixnum, Hash)>] V1UpdateInspectionsResponse data, response status code and response headers
    def update_inspections_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: InspectionServiceApi.update_inspections ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling InspectionServiceApi.update_inspections" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/inspections/update".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1UpdateInspectionsResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: InspectionServiceApi#update_inspections\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
