=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require "uri"

module HappyCo
  class TemplateServiceApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1SetTemplatesArchivedResponse]
    def archive_templates(body, opts = {})
      data, _status_code, _headers = archive_templates_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1SetTemplatesArchivedResponse, Fixnum, Hash)>] V1SetTemplatesArchivedResponse data, response status code and response headers
    def archive_templates_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: TemplateServiceApi.archive_templates ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling TemplateServiceApi.archive_templates" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/templates/archive".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1SetTemplatesArchivedResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplateServiceApi#archive_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1CreateTemplatesResponse]
    def create_templates(body, opts = {})
      data, _status_code, _headers = create_templates_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1CreateTemplatesResponse, Fixnum, Hash)>] V1CreateTemplatesResponse data, response status code and response headers
    def create_templates_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: TemplateServiceApi.create_templates ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling TemplateServiceApi.create_templates" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/templates/create".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1CreateTemplatesResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplateServiceApi#create_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1ListTemplatesResponse]
    def list_templates(body, opts = {})
      data, _status_code, _headers = list_templates_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1ListTemplatesResponse, Fixnum, Hash)>] V1ListTemplatesResponse data, response status code and response headers
    def list_templates_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: TemplateServiceApi.list_templates ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling TemplateServiceApi.list_templates" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/templates/list".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1ListTemplatesResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplateServiceApi#list_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1SetTemplatesArchivedResponse]
    def unarchive_templates(body, opts = {})
      data, _status_code, _headers = unarchive_templates_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1SetTemplatesArchivedResponse, Fixnum, Hash)>] V1SetTemplatesArchivedResponse data, response status code and response headers
    def unarchive_templates_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: TemplateServiceApi.unarchive_templates ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling TemplateServiceApi.unarchive_templates" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/templates/unarchive".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1SetTemplatesArchivedResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplateServiceApi#unarchive_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [V1UpdateTemplatesResponse]
    def update_templates(body, opts = {})
      data, _status_code, _headers = update_templates_with_http_info(body, opts)
      return data
    end

    # 
    # 
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(V1UpdateTemplatesResponse, Fixnum, Hash)>] V1UpdateTemplatesResponse data, response status code and response headers
    def update_templates_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: TemplateServiceApi.update_templates ..."
      end
      # verify the required parameter 'body' is set
      fail ArgumentError, "Missing the required parameter 'body' when calling TemplateServiceApi.update_templates" if body.nil?
      # resource path
      local_var_path = "/api/v1/inspect/templates/update".sub('{format}','json')

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}

      # HTTP header 'Accept' (if needed)
      local_header_accept = ['application/json']
      local_header_accept_result = @api_client.select_header_accept(local_header_accept) and header_params['Accept'] = local_header_accept_result

      # HTTP header 'Content-Type'
      local_header_content_type = ['application/json']
      header_params['Content-Type'] = @api_client.select_header_content_type(local_header_content_type)

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(body)
      auth_names = []
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'V1UpdateTemplatesResponse')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TemplateServiceApi#update_templates\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
