module HappyCo
  class << self
    def id(v)
      HappyCo::V1IntegrationID.new(id: v.to_s)
    end

    def my_id(v)
      HappyCo::V1IntegrationID.new(external_id: v.to_s)
    end

    def dev_api(user, pass)
      api(user,pass,"grpc.dev.happyco.com")
    end

    def staging_api(user, pass)
      api(user,pass,"grpc.staging.happyco.com")
    end

    def prod_api(user,pass)
      api(user,pass,"grpc.happyco.com")
    end

    def api(user,pass,host="grpc.happyco.com")
      HappyCo.configure { |config|
        config.host = "#{host}"
        config.scheme = "https"
        config.base_path = ''
        config.username = user
        config.password = pass
        config.debugging = true
      }
      client = HappyCo::ApiClient.new
      client.default_headers = {'Authorization' => HappyCo.configure.basic_auth_token}
      return client
    end
  end
end
