=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'date'

module HappyCo
  # * Inspection represents an inspection in its 3 states: scheduled, in_progress and completed.
  class V1Inspection
    # * ID of inspection.
    attr_accessor :id

    # * Account ID that the inspection belongs to.
    attr_accessor :account_id

    attr_accessor :folder_id

    # * Asset is the parent that inspection is attached to. This field must reference a non archived asset in the same folder as the template referenced below.
    attr_accessor :asset_id

    # * Template is the prototype of an inspection thats allow it to be configured on the fly. This field must reference a non archived template in the same folder as the parent asset referenced above.
    attr_accessor :template_id

    # * Template outline when set on a scheduled inspection forces a different outline prototype to be used when the inspection moves from scheduled to in_progress.
    attr_accessor :template_outline

    attr_accessor :scheduled

    attr_accessor :in_progress

    attr_accessor :completed

    attr_accessor :update_time

    # * Photo Quality is an override setting sent to clients that informs them what level of Photo Quality they should enforce, regardless of user settings on the client. The default value is 0 which denotes that the client should use the user's settings, otherwise the higher the value the higher Photo Quality should be enforced by the client.
    attr_accessor :photo_quality

    # * Inspector ID is an optional field that specifies the user assigned to perform the inspection.
    attr_accessor :assigned_to_id


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'account_id' => :'account_id',
        :'folder_id' => :'folder_id',
        :'asset_id' => :'asset_id',
        :'template_id' => :'template_id',
        :'template_outline' => :'template_outline',
        :'scheduled' => :'scheduled',
        :'in_progress' => :'in_progress',
        :'completed' => :'completed',
        :'update_time' => :'update_time',
        :'photo_quality' => :'photo_quality',
        :'assigned_to_id' => :'assigned_to_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'V1IntegrationID',
        :'account_id' => :'V1IntegrationID',
        :'folder_id' => :'V1IntegrationID',
        :'asset_id' => :'V1IntegrationID',
        :'template_id' => :'V1IntegrationID',
        :'template_outline' => :'String',
        :'scheduled' => :'V1ScheduledInspection',
        :'in_progress' => :'V1InspectionData',
        :'completed' => :'V1InspectionData',
        :'update_time' => :'V1DateTime',
        :'photo_quality' => :'Integer',
        :'assigned_to_id' => :'V1IntegrationID'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.has_key?(:'folder_id')
        self.folder_id = attributes[:'folder_id']
      end

      if attributes.has_key?(:'asset_id')
        self.asset_id = attributes[:'asset_id']
      end

      if attributes.has_key?(:'template_id')
        self.template_id = attributes[:'template_id']
      end

      if attributes.has_key?(:'template_outline')
        self.template_outline = attributes[:'template_outline']
      end

      if attributes.has_key?(:'scheduled')
        self.scheduled = attributes[:'scheduled']
      end

      if attributes.has_key?(:'in_progress')
        self.in_progress = attributes[:'in_progress']
      end

      if attributes.has_key?(:'completed')
        self.completed = attributes[:'completed']
      end

      if attributes.has_key?(:'update_time')
        self.update_time = attributes[:'update_time']
      end

      if attributes.has_key?(:'photo_quality')
        self.photo_quality = attributes[:'photo_quality']
      end

      if attributes.has_key?(:'assigned_to_id')
        self.assigned_to_id = attributes[:'assigned_to_id']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          account_id == o.account_id &&
          folder_id == o.folder_id &&
          asset_id == o.asset_id &&
          template_id == o.template_id &&
          template_outline == o.template_outline &&
          scheduled == o.scheduled &&
          in_progress == o.in_progress &&
          completed == o.completed &&
          update_time == o.update_time &&
          photo_quality == o.photo_quality &&
          assigned_to_id == o.assigned_to_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, account_id, folder_id, asset_id, template_id, template_outline, scheduled, in_progress, completed, update_time, photo_quality, assigned_to_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = HappyCo.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
