=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'date'

module HappyCo
  # * Inspection data has fields containing all of the inspection data for an inspection with a status of in_progress or completed.
  class V1InspectionData
    # * Started at is a non optional field that is set to the actual time that an inspection transitions from scheduled to in_progress. This time comes from the device where the transition occurs on as the user may be offline.
    attr_accessor :started_at

    # * Ended at is an optional field for in_progress inspections but required for completed inspections. It is set to the actual time that an inspection transtions from in_progress to complete. This time comes from the device where the transition occurs as the suer may be offline.
    attr_accessor :ended_at

    # * User started at is an optional field that can appear on reports. This can be updated by the user to a specific time. When an inspection transitions from scheduled to in_progress the schedule_date becomes this field.
    attr_accessor :user_started_at

    # * User ended at is an optional field that can appear on reports. This can be updated by the user to a specific time.
    attr_accessor :user_ended_at

    # * HeaderFields are shown on the top of an inspection and reports generated from it.
    attr_accessor :header_fields

    # * Sections and their items hold most of the inspection data; selected ratings, notes, and photos.
    attr_accessor :sections

    # * FooterFields are shown at the end of an inspection and reports generated from it.
    attr_accessor :footer_fields

    # * Rating groups is a map of unique keys within an inspection to rating groups. Each item within this inspection must reference a rating group with a key in this map.
    attr_accessor :rating_groups


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'started_at' => :'started_at',
        :'ended_at' => :'ended_at',
        :'user_started_at' => :'user_started_at',
        :'user_ended_at' => :'user_ended_at',
        :'header_fields' => :'header_fields',
        :'sections' => :'sections',
        :'footer_fields' => :'footer_fields',
        :'rating_groups' => :'rating_groups'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'started_at' => :'V1DateTime',
        :'ended_at' => :'V1DateTime',
        :'user_started_at' => :'V1DateTime',
        :'user_ended_at' => :'V1DateTime',
        :'header_fields' => :'Array<V1HeaderField>',
        :'sections' => :'Array<V1Section>',
        :'footer_fields' => :'Array<V1FooterField>',
        :'rating_groups' => :'Hash<String, V1RatingGroup>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'started_at')
        self.started_at = attributes[:'started_at']
      end

      if attributes.has_key?(:'ended_at')
        self.ended_at = attributes[:'ended_at']
      end

      if attributes.has_key?(:'user_started_at')
        self.user_started_at = attributes[:'user_started_at']
      end

      if attributes.has_key?(:'user_ended_at')
        self.user_ended_at = attributes[:'user_ended_at']
      end

      if attributes.has_key?(:'header_fields')
        if (value = attributes[:'header_fields']).is_a?(Array)
          self.header_fields = value
        end
      end

      if attributes.has_key?(:'sections')
        if (value = attributes[:'sections']).is_a?(Array)
          self.sections = value
        end
      end

      if attributes.has_key?(:'footer_fields')
        if (value = attributes[:'footer_fields']).is_a?(Array)
          self.footer_fields = value
        end
      end

      if attributes.has_key?(:'rating_groups')
        if (value = attributes[:'rating_groups']).is_a?(Array)
          self.rating_groups = value
        end
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          started_at == o.started_at &&
          ended_at == o.ended_at &&
          user_started_at == o.user_started_at &&
          user_ended_at == o.user_ended_at &&
          header_fields == o.header_fields &&
          sections == o.sections &&
          footer_fields == o.footer_fields &&
          rating_groups == o.rating_groups
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [started_at, ended_at, user_started_at, user_ended_at, header_fields, sections, footer_fields, rating_groups].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = HappyCo.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
