=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'date'

module HappyCo
  # * Item contains most of the inspection information such as; selected rating values, notes and photos. The name of an item should make sense in context of the section which they are a child of. An item corresponds to an individual inspection row within the inspection.
  class V1Item
    # * Name is an optional field but should be set to something that makes sense in context of the parent section. For example; 'Kitchen': 'Sink', 'Floor 1': 'Water Heater'.
    attr_accessor :name

    # * Notes is an optional field where inspectors can type custom notes (optionally using SnapText) that pertain to this item.
    attr_accessor :notes

    # * Info is an optional field that can be used to provide helpful information to the inspector. It is not shown on the report and is primarily used to help training.
    attr_accessor :info

    # * Photos data can be added with the AddInspectionPhotos api.
    attr_accessor :photos

    # * Rating group key is a string that can be used to access a rating group from the parent inspection. A rating group must exist for this key within the inspection for the value to be valid.
    attr_accessor :rating_group_key

    # * Values are a map of rating keys and the selected value(s). That can be referenced using the item's associated rating group.
    attr_accessor :values

    # * Scores are a map of rating keys and the selected score(s). That can be referenced using the item's associated rating group.
    attr_accessor :scores

    # * Task work category ID is an optional field that can be used to assign a task to an item. Note that this is only useful when a business has access to Tasks.
    attr_accessor :task_work_category_id


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'name' => :'name',
        :'notes' => :'notes',
        :'info' => :'info',
        :'photos' => :'photos',
        :'rating_group_key' => :'rating_group_key',
        :'values' => :'values',
        :'scores' => :'scores',
        :'task_work_category_id' => :'task_work_category_id'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'name' => :'String',
        :'notes' => :'String',
        :'info' => :'String',
        :'photos' => :'Array<V1Photo>',
        :'rating_group_key' => :'String',
        :'values' => :'Hash<String, V1RatingValues>',
        :'scores' => :'Hash<String, V1FloatArray>',
        :'task_work_category_id' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'notes')
        self.notes = attributes[:'notes']
      end

      if attributes.has_key?(:'info')
        self.info = attributes[:'info']
      end

      if attributes.has_key?(:'photos')
        if (value = attributes[:'photos']).is_a?(Array)
          self.photos = value
        end
      end

      if attributes.has_key?(:'rating_group_key')
        self.rating_group_key = attributes[:'rating_group_key']
      end

      if attributes.has_key?(:'values')
        if (value = attributes[:'values']).is_a?(Array)
          self.values = value
        end
      end

      if attributes.has_key?(:'scores')
        if (value = attributes[:'scores']).is_a?(Array)
          self.scores = value
        end
      end

      if attributes.has_key?(:'task_work_category_id')
        self.task_work_category_id = attributes[:'task_work_category_id']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          name == o.name &&
          notes == o.notes &&
          info == o.info &&
          photos == o.photos &&
          rating_group_key == o.rating_group_key &&
          values == o.values &&
          scores == o.scores &&
          task_work_category_id == o.task_work_category_id
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [name, notes, info, photos, rating_group_key, values, scores, task_work_category_id].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = HappyCo.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
