=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'date'

module HappyCo
  # * List report request is used for fetching reports. It can be filtered to specific reports, assets or folders. If the intent is to be notified when an report undergoes a status transition please use the ReportEventService.
  class V1ListReportsRequest
    # * Account ID that the request applies to. For custom integrations (i.e. not integration partners) it can be omitted.
    attr_accessor :account_id

    # * Folder IDs is an optional filter that lists reports only for specific folders.
    attr_accessor :folder_ids

    # * Asset IDs is an optional filter that lists reports only for specific assets.
    attr_accessor :asset_ids

    # * Inspections IDs is an optional filter that lists reports only for specific inspections.
    attr_accessor :inspection_ids

    # * Report IDs is an optional filter that lists reports only for specific reports.
    attr_accessor :report_ids

    # * Archived when set to true returns archived reports only.
    attr_accessor :archived

    # * Paging message that contains information about the page being requested. This message is usually copied from a previous list request's response.
    attr_accessor :paging


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'account_id' => :'account_id',
        :'folder_ids' => :'folder_ids',
        :'asset_ids' => :'asset_ids',
        :'inspection_ids' => :'inspection_ids',
        :'report_ids' => :'report_ids',
        :'archived' => :'archived',
        :'paging' => :'paging'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'account_id' => :'V1IntegrationID',
        :'folder_ids' => :'Array<V1IntegrationID>',
        :'asset_ids' => :'Array<V1IntegrationID>',
        :'inspection_ids' => :'Array<V1IntegrationID>',
        :'report_ids' => :'Array<V1IntegrationID>',
        :'archived' => :'BOOLEAN',
        :'paging' => :'V1Paging'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.has_key?(:'folder_ids')
        if (value = attributes[:'folder_ids']).is_a?(Array)
          self.folder_ids = value
        end
      end

      if attributes.has_key?(:'asset_ids')
        if (value = attributes[:'asset_ids']).is_a?(Array)
          self.asset_ids = value
        end
      end

      if attributes.has_key?(:'inspection_ids')
        if (value = attributes[:'inspection_ids']).is_a?(Array)
          self.inspection_ids = value
        end
      end

      if attributes.has_key?(:'report_ids')
        if (value = attributes[:'report_ids']).is_a?(Array)
          self.report_ids = value
        end
      end

      if attributes.has_key?(:'archived')
        self.archived = attributes[:'archived']
      end

      if attributes.has_key?(:'paging')
        self.paging = attributes[:'paging']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          account_id == o.account_id &&
          folder_ids == o.folder_ids &&
          asset_ids == o.asset_ids &&
          inspection_ids == o.inspection_ids &&
          report_ids == o.report_ids &&
          archived == o.archived &&
          paging == o.paging
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [account_id, folder_ids, asset_ids, inspection_ids, report_ids, archived, paging].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = HappyCo.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
