=begin
#Merged swaggers

#All happy services merged together 

OpenAPI spec version: 2.7.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

=end

require 'date'

module HappyCo
  # * Rating groups have an optional label that can be useful for selecting a rating group during the item insert or update process. A rating group is what makes up the form controls for each item row in an inspection.
  class V1RatingGroup
    # * Label is an optional field that can help users that need to update inspections on the fly.
    attr_accessor :label

    # * Ratings are the ordered set of rating controls an inspector sees for an item that references this rating group.
    attr_accessor :ratings

    # * Requires Photo is an optional map of Rating Control key to an array of Rating (Dropdown / Radio) Option value or Checkbox value for all for all values that require a photo.  Deprecated: set minimum_photos on the option instead.
    attr_accessor :requires_photo

    attr_accessor :requires_note

    attr_accessor :requires_value

    attr_accessor :requires_score

    # * Minimum Photos is the minimum number of photos required to fulfil an item that has this rating group.
    attr_accessor :minimum_photos


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'label' => :'label',
        :'ratings' => :'ratings',
        :'requires_photo' => :'requires_photo',
        :'requires_note' => :'requires_note',
        :'requires_value' => :'requires_value',
        :'requires_score' => :'requires_score',
        :'minimum_photos' => :'minimum_photos'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'label' => :'String',
        :'ratings' => :'Array<V1RatingControl>',
        :'requires_photo' => :'Hash<String, V1StringArray>',
        :'requires_note' => :'Hash<String, V1StringArray>',
        :'requires_value' => :'BOOLEAN',
        :'requires_score' => :'Hash<String, V1StringArray>',
        :'minimum_photos' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'label')
        self.label = attributes[:'label']
      end

      if attributes.has_key?(:'ratings')
        if (value = attributes[:'ratings']).is_a?(Array)
          self.ratings = value
        end
      end

      if attributes.has_key?(:'requires_photo')
        if (value = attributes[:'requires_photo']).is_a?(Array)
          self.requires_photo = value
        end
      end

      if attributes.has_key?(:'requires_note')
        if (value = attributes[:'requires_note']).is_a?(Array)
          self.requires_note = value
        end
      end

      if attributes.has_key?(:'requires_value')
        self.requires_value = attributes[:'requires_value']
      end

      if attributes.has_key?(:'requires_score')
        if (value = attributes[:'requires_score']).is_a?(Array)
          self.requires_score = value
        end
      end

      if attributes.has_key?(:'minimum_photos')
        self.minimum_photos = attributes[:'minimum_photos']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properies with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          label == o.label &&
          ratings == o.ratings &&
          requires_photo == o.requires_photo &&
          requires_note == o.requires_note &&
          requires_value == o.requires_value &&
          requires_score == o.requires_score &&
          minimum_photos == o.minimum_photos
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [label, ratings, requires_photo, requires_note, requires_value, requires_score, minimum_photos].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /^(true|t|yes|y|1)$/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = HappyCo.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
